#include "TNOSQL.CH"

/*
Ŀ
 Programa:     tno01.prg                                                 
 Parmetros:   Ninguno                                                   
 Utilidad:     Prueba de conexin y desconexin de la base               
Ĵ
 Compilacin y enlace:                                                   
 clipper tno01 /w /n                                                     
 blinker fi tno01 li tnosql1                                             

 
*/

FUNC tno01()

   LOCAL hCursor, nError

   Presenta()

   /// Conexin a la base demo
   QOut( "Conectandose ..." )
   IF ( nError := sqlCntCursor( @hCursor, "DEMO" ) ) == 0

      sql_Succes( "Conexin establecida (Manipulador=" + ;
      LTrim( Str( hCursor ) ) + ')' )

      QOut( "Presione una tecla para continuar ..." )
      InKey( 0 )

      /// Desconexin de la base
      sqlDisCursor( hCursor )

   ELSE
      sql_Error( nError )
      InKey( 5 )
   ENDIF  

   Bye()

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Error()                                               
 Parmetros:   Cdigo de error                                           
 Utilidad:     Displaya el mensaje del error en rojo                     

 
*/

STAT FUNC sql_Error( nError )
   LOCAL cColor := SetColor( "r/n" )

   QOut( sqlErrorMsg( nError ) )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Success()                                             
 Parmetros:   Mensaje a displayar                                       
 Utilidad:     Displaya el mensaje en color verde                        

 
*/

STAT FUNC sql_Success( cMsg )
   LOCAL cColor := SetColor( "g/n" )

   QOut( cMsg )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      Presenta()                                                
 Parmetros:   Pantalla de TNO-SQL 1.0                                   
 Utilidad:     Displaya la pantalla del producto                         

 
*/

STAT FUNC Presenta()
   LOCAL nCursor := SetCursor( 0 )

   IF File( "TNOSQL.SCR" )
      RestScreen( 0, 0, 24, 79, MemoRead( "TNOSQL.SCR" ) )
      InKey( 10 )
   ENDIF                          

   Scroll()
   SetCursor( nCursor )
RETURN ( Nil )



/*
Ŀ
 Funcin:      Bye()                                                     
 Parmetros:   Ninguno                                                   
 Utilidad:     Displaya la pantalla del final                            

 
*/

STAT FUNC Bye()
   Scroll()   
   @ 0, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   @ 1, 0 SAY PadC( "TNO-SQL 1.0 para Gupta SQLBase 5.0", 80 ) COLOR "w/n"
   @ 2, 0 SAY PadC( "por Guillermo Gisinger", 80 ) COLOR "w/n"
   @ 4, 0 SAY PadC( "Copyright (c) The New Order Corporation  1994", 80 ) ;
   COLOR "w/n"
   @ 5, 0 SAY PadC( "All Rights Reserved", 80 ) COLOR "w/n"
   @ 6, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   SetPos( 8, 0 )
RETURN ( Nil )



/// by LMN   |-)
