#include "TNOSQL.CH"
#include "INKEY.CH"
#include "SET.CH"

/*
Ŀ
 Programa:     tno02.prg                                                 
 Parmetros:   Ninguno                                                   
 Utilidad:     Conexin y desconexin de la base usando los valores por  
               defecto                                                   
Ĵ
 Compilacin y enlace:                                                   
 clipper tno02 /w /n                                                     
 blinker fi tno02 li tnosql1                                             

 
*/

FUNC tno02()

   LOCAL hCursor, nError
   LOCAL cDBase, cUser, cPswd

   LOCAL GetList := {}

   SetColor( "w/n,+w/b,,,+gr/n" )
   SetCursor( 3 )
   Set( _SET_CONFIRM, "ON" )

   Presenta()

   /// Obtencin de la base, usuario y password por defecto del archivo
   /// SQL.ini 
   cDBase := PadR( sqlGetPar( 0, SQLPDDB ), 8 )
   cUser  := PadR( sqlGetPar( 0, SQLPDUS ), 8 )
   cPswd  := PadR( sqlGetPar( 0, SQLPDPW ), 8 ) 

   @ 0, 0 SAY "Ingrese los datos para la conexin"
   @ 2, 2 SAY "Base de datos:     " GET cDBase PICTURE "@K!"
   @ 3, 2 SAY "Nombre de usuario: " GET cUser  PICTURE "@K!"
   @ 4, 2 SAY "Clave de usuario:  " GET cPswd  PICTURE "@K!"

   READ                                       

   SetPos( 6, 0 )

   IF ( LastKey() != K_ESC )              

      /// Conexin a la base de datos
      QOut( "Conectandose a la base ..." )
      nError := sqlCntCursor( @hCursor, ;
      RTrim( cDBase ) + '/' + RTrim( cUser ) + '/' + RTrim( cPswd ) )

      IF ( nError == 0 )
         sql_Succes( "Conexin establecida (Manipulador=" + ;
         LTrim( Str( hCursor ) ) + ')' )

         QOut( "Presione una tecla para continuar ..." )
         InKey( 0 )

         /// Desconexin de la base
         sqlDisCursor( hCursor )
      ELSE
         sql_Error( nError )
         InKey( 5 )
      ENDIF

   ENDIF

   Bye()

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Error()                                               
 Parmetros:   Cdigo de error                                           
 Utilidad:     Displaya el mensaje del error en rojo                     

 
*/

STAT FUNC sql_Error( nError )
   LOCAL cColor := SetColor( "r/n" )

   QOut( sqlErrorMsg( nError ) )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Success()                                             
 Parmetros:   Mensaje a displayar                                       
 Utilidad:     Displaya el mensaje en color verde                        

 
*/

STAT FUNC sql_Success( cMsg )
   LOCAL cColor := SetColor( "g/n" )

   QOut( cMsg )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      Presenta()                                                
 Parmetros:                                                             
 Utilidad:     Displaya la pantalla del producto                         

 
*/

STAT FUNC Presenta()
   LOCAL nCursor := SetCursor( 0 )

   IF File( "TNOSQL.SCR" )
      RestScreen( 0, 0, 24, 79, MemoRead( "TNOSQL.SCR" ) )
      InKey( 10 )
   ENDIF                          

   Scroll()
   SetCursor( nCursor )
RETURN ( Nil )



/*
Ŀ
 Funcin:      Bye()                                                     
 Parmetros:   Ninguno                                                   
 Utilidad:     Displaya la pantalla del final                            

 
*/

STAT FUNC Bye()
   Scroll()   
   @ 0, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   @ 1, 0 SAY PadC( "TNO-SQL 1.0 para Gupta SQLBase 5.0", 80 ) COLOR "w/n"
   @ 2, 0 SAY PadC( "por Guillermo Gisinger", 80 ) COLOR "w/n"
   @ 4, 0 SAY PadC( "Copyright (c) The New Order Corporation  1994", 80 ) ;
   COLOR "w/n"
   @ 5, 0 SAY PadC( "All Rights Reserved", 80 ) COLOR "w/n"
   @ 6, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   SetPos( 8, 0 )
RETURN ( Nil )



/// by LMN   |-)

