#include "TNOSQL.CH"

/*
Ŀ
 Programa:     tno04.prg                                                 
 Parmetros:   Ninguno                                                   
 Utilidad:     Llenado de tabla desde archivo DBF (variables de enlace)  
Ĵ
 Compilacin y enlace:                                                   
 clipper tno04 /w /n                                                     
 blinker fi tno04 li tnosql1                                             

 
*/

FUNC tno04()

   LOCAL hCursor, nError

   Presenta()

   /// Conexin a la base de datos
   QOut( "Conectandose a la base ..." )

   IF ( nError := sqlCntCursor( @hCursor, "DEMO" ) ) == 0
      sql_Success( "Conexin satisfactoria ..." )

      /// Carga de comando
      IF sqlRtveCmd( hCursor, "TNOINSERT" )

         /// Inicializacin de buffers de enlace
         sqlBndInit( hCursor )

         /// Base desde la que se insertarn las filas
         DBSelectArea( 1 )
         DBUseArea( ,, "TNODEMO" )

         QOut(); QOut(); QOut( "Agregando registros " )
         
         WHILE (1)->( !EoF() )
            QQOut( '.' )

            /// Enlazado de variables
            sqlBndData( hCursor, 1, XToSQL( (1)->CODIGO ) )
            sqlBndData( hCursor, 2, XToSQL( (1)->NOMBRE ) )
            sqlBndData( hCursor, 3, XToSQL( (1)->FECNAC ) )

            /// Ejecucin del comando
            sqlExeCmd( hCursor )

            /// Limpieza de buffers de enlace
            sqlBndClr( hCursor )
         
            (1)->( DBSkip( 1 ) )
         ENDDO
         
         DBCloseArea()
         
         /// Liberacin de buffers
         sqlBndTer( hCursor )

         /// Confirmacin de transaccin
         sqlCommit( hCursor )
      ELSE
         sql_Error( sqlLastCode( hCursor ) )
         InKey( 5 )
      ENDIF
  
      /// Desconexin de la base de datos
      sqlDisCursor( hCursor )

   ELSE
      sql_Error( nError )
      InKey( 5 )
   ENDIF

   Bye()

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Error()                                               
 Parmetros:   Cdigo de error                                           
 Utilidad:     Displaya el mensaje del error en rojo                     

 
*/

STAT FUNC sql_Error( nError )
   LOCAL cColor := SetColor( "r/n" )

   QOut( sqlErrorMsg( nError ) )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Success()                                             
 Parmetros:   Mensaje a displayar                                       
 Utilidad:     Displaya el mensaje en color verde                        

 
*/

STAT FUNC sql_Success( cMsg )
   LOCAL cColor := SetColor( "g/n" )

   QOut( cMsg )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      Presenta()                                                
 Parmetros:   Pantalla de TNO-SQL 1.0                                   
 Utilidad:     Displaya la pantalla del producto                         

 
*/

STAT FUNC Presenta()
   LOCAL nCursor := SetCursor( 0 )

   IF File( "TNOSQL.SCR" )
      RestScreen( 0, 0, 24, 79, MemoRead( "TNOSQL.SCR" ) )
      InKey( 10 )
   ENDIF                          

   Scroll()
   SetCursor( nCursor )
RETURN ( Nil )



/*
Ŀ
 Funcin:      Bye()                                                     
 Parmetros:   Ninguno                                                   
 Utilidad:     Displaya la pantalla del final                            

 
*/

STAT FUNC Bye()
   Scroll()   
   @ 0, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   @ 1, 0 SAY PadC( "TNO-SQL 1.0 para Gupta SQLBase 5.0", 80 ) COLOR "w/n"
   @ 2, 0 SAY PadC( "por Guillermo Gisinger", 80 ) COLOR "w/n"
   @ 4, 0 SAY PadC( "Copyright (c) The New Order Corporation  1994", 80 ) ;
   COLOR "w/n"
   @ 5, 0 SAY PadC( "All Rights Reserved", 80 ) COLOR "w/n"
   @ 6, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   SetPos( 8, 0 )
RETURN ( Nil )



/// by LMN   |-)
