#include "TNOSQL.CH"
#include "SET.CH"
#include "INKEY.CH"

/*
Ŀ
 Programa:     tno05.prg                                                 
 Parmetros:   Ninguno                                                   
 Utilidad:     TBrowse() de la tabla TNODEMO                             
Ĵ
 Compilacin y enlace:                                                   
 clipper tno05 /w /n                                                     
 blinker fi tno0  li tnosql1                                             

 
*/

FUNC tno05()

   LOCAL hCursor, nError, nKey := 0
   LOCAL oSql, nRows, nPos := 1

   Set( _SET_DATEFORMAT, "dd/mm/yyyy" )

   Presenta()

   /// Conexin a la base
   QOut( "Conectandose a la base de datos ..." )

   IF ( nError := sqlCntCursor( @hCursor, "DEMO" ) ) == 0
      sql_Success( "Conexin realizada satisfactoriamente ..." )

      /// Fijacin del set de resultados
      sqlStartRR( hCursor )
      sqlStopRtn( hCursor )

      /// Nivel de aislamiento RL
      IF sqlIsoLevel( hCursor, SQLILRL )

         /// Compilacin del comando SELECT
         IF sqlComCmd( hCursor, "SELECT * FROM TNODEMO" )

            /// Inicializacin de buffers de enlace
            IF ( nError := sqlQryInit( hCursor ) ) == 0

               /// Cantidad de filas
               nRows := sqlSELRows( hCursor ) 
               QOut( LTrim( Str( nRows ) ) + " filas ..." ); InKey( 2 )

               Scroll()
               @ 12, 2 SAY "Presione ESCAPE para terminar ..." COLOR "+gr/n"
               oSql := TBrowseNew( 0, 0, 10, 79 )
               oSql:HeadSep := ""
               oSql:ColSep  := "  "
               oSql:ColorSpec := "w/n,+w/rb"

               oSql:GoTopBlock    := { || nPos := 1, sqlSetRow( 1 ) }
               oSql:SkipBlock     := { |n| sqlSkip( n, @nPos, nRows, ;
                                     hCursor ) }
               oSql:GoBottomBlock := { || nPos := nRows, ;
                                     sqlSetRow( nRows ) }

               oSql:AddColumn( TBColumnNew( "CODIGO", ;
               { || Str( sqlQryCol( hCursor, 1 ), 4 ) } ) )
               oSql:AddColumn( TBColumnNew( "NOMBRE", ;
               { || sqlQryCol( hCursor, 2 ) } ) )
               oSql:AddColumn( TBColumnNew( "FECHA", ;
               { || DToC( sqlQryCol( hCursor, 3 ) ) } ) )

               WHILE nKey != K_ESC

                  /// Estabilizacin del tbrowse
                  WHILE !oSql:Stabilize()
                  ENDDO

                  /// Se llego al fin o al principio del query?
                  IF oSql:HitTop .OR. oSql:HitBottom
                     Tone( 300, 1 )
                     oSql:HitTop := oSql:HitBottom := .F.
                  ENDIF

                  nKey := InKey( 0 )

                  DO CASE
                     CASE nKey == K_UP
                        oSql:Up()
                     CASE nKey == K_DOWN
                        oSql:Down()
                     CASE nKey == K_PGUP
                        oSql:PageUp()
                     CASE nKey == K_PGDN
                        oSql:PageDown()
                     CASE nKey == K_HOME
                        oSql:GoTop()
                     CASE nKey == K_END
                        oSql:GoBottom()
                     CASE nKey == K_LEFT
                        oSql:Left()
                     CASE nKey == K_RIGHT
                        oSql:Right()
                  ENDCASE
               ENDDO

               /// Limpieza de buffers de enlace
               sqlQryClr( hCursor )

            ELSE
               sql_Error( nError )
               InKey( 5 )
            ENDIF

         ELSE
            sql_Error( sqlLastCode( hCursor ) )
            InKey( 5 )
         ENDIF

      ELSE
         sql_Error( sqlLastCode( hCursor ) )
         InKey( 5 )
      ENDIF

      /// Desconexin de la base
      sqlDisCursor( hCursor )

   ELSE
      sql_Error( nError )
      InKey( 5 )
   ENDIF

   Bye()

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Error()                                               
 Parmetros:   Cdigo de error                                           
 Utilidad:     Displaya el mensaje del error en rojo                     

 
*/

STAT FUNC sql_Error( nError )
   LOCAL cColor := SetColor( "r/n" )

   QOut( sqlErrorMsg( nError ) )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      sql_Success()                                             
 Parmetros:   Mensaje a displayar                                       
 Utilidad:     Displaya el mensaje en color verde                        

 
*/

STAT FUNC sql_Success( cMsg )
   LOCAL cColor := SetColor( "g/n" )

   QOut( cMsg )
   SetColor( cColor )

RETURN ( Nil )



/*
Ŀ
 Funcin:      Presenta()                                                
 Parmetros:   Pantalla de TNO-SQL 1.0                                   
 Utilidad:     Displaya la pantalla del producto                         

 
*/

STAT FUNC Presenta()
   LOCAL nCursor := SetCursor( 0 )

   IF File( "TNOSQL.SCR" )
      RestScreen( 0, 0, 24, 79, MemoRead( "TNOSQL.SCR" ) )
      InKey( 10 )
   ENDIF                          

   Scroll()
   SetCursor( nCursor )
RETURN ( Nil )



/*
Ŀ
 Funcin:      Bye()                                                     
 Parmetros:   Ninguno                                                   
 Utilidad:     Displaya la pantalla del final                            

 
*/

STAT FUNC Bye()
   Scroll()   
   @ 0, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   @ 1, 0 SAY PadC( "TNO-SQL 1.0 para Gupta SQLBase 5.0", 80 ) COLOR "w/n"
   @ 2, 0 SAY PadC( "por Guillermo Gisinger", 80 ) COLOR "w/n"
   @ 4, 0 SAY PadC( "Copyright (c) The New Order Corporation  1994", 80 ) ;
   COLOR "w/n"
   @ 5, 0 SAY PadC( "All Rights Reserved", 80 ) COLOR "w/n"
   @ 6, 0 SAY Replicate( '', 80 ) COLOR "+b/n"
   SetPos( 8, 0 )
RETURN ( Nil )



/// by LMN   |-)
